Page MenuHomePhabricator

Update Adyen SmashPig code to be able to create recurring donations
Closed, ResolvedPublic

Description

Two steps needed, authorize and capture.

Event Timeline

Cstone created this task.Jan 8 2020, 8:10 PM
Ejegg added a subscriber: Ejegg.EditedJan 8 2020, 9:36 PM

There is an existing wrapper class around the SOAP calls: https://phabricator.wikimedia.org/diffusion/WFSP/browse/master/PaymentProviders/Adyen/AdyenPaymentsAPI.php

This task should probably involve rearranging the wrapper code to closer match the PaymentProvider classes in Ingenico: https://phabricator.wikimedia.org/diffusion/WFSP/browse/master/PaymentProviders/Ingenico/

... as well as adding the authorize call.

Also, when we start authorizing recurring payments via the API, Adyen will send us IPN messages that look a lot like the ones they send us for payments authorized via HPP. Our logic to process those IPNs will have to distinguish between HPP-initiated (which the IPN processor needs to capture or cancel) and schedule-initiated (which the IPN processor can ignore, because the scheduled job will capture them). One distinguishing mark might be the absence of a CVC result for things we've authorized from the scheduler.

Ejegg added a comment.Jan 14 2020, 9:12 PM

Adding the authorize call can be an opportunity to define the normalization of the API responses.
So for example instead of passing back { 'pspReference':1234567 } it would pass back { 'gateway_txn_id':1234567 }

XenoRyet removed XenoRyet as the assignee of this task.Jan 15 2020, 6:31 PM

Change 565131 had a related patch set uploaded (by Jgleeson; owner: Jgleeson):
[wikimedia/fundraising/SmashPig@master] WIP: Update Adyen SmashPig code to be able to create recurring donations

https://gerrit.wikimedia.org/r/565131

.Nafees791 renamed this task from Update Adyen SmashPig code to be able to create recurring donations to smui.Jan 23 2020, 4:26 AM
.Nafees791 closed this task as Declined.
.Nafees791 removed jgleeson as the assignee of this task.
.Nafees791 triaged this task as Low priority.
.Nafees791 updated the task description. (Show Details)
.Nafees791 edited subscribers, added: jgleeson; removed: Ejegg, DStrine, Aklapper and 3 others.
ArielGlenn renamed this task from smui to Update Adyen SmashPig code to be able to create recurring donations.Jan 23 2020, 9:02 AM
ArielGlenn reopened this task as Open.
ArielGlenn assigned this task to jgleeson.
ArielGlenn raised the priority of this task from Low to Needs Triage.
ArielGlenn updated the task description. (Show Details)
ArielGlenn edited subscribers, added: Ejegg, DStrine, Aklapper and 3 others; removed: jgleeson.

Change 565131 merged by jenkins-bot:
[wikimedia/fundraising/SmashPig@master] Update Adyen SmashPig code to be able to create recurring donations

https://gerrit.wikimedia.org/r/565131

Change 576918 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[wikimedia/fundraising/SmashPig@master] Adyen recurring: fix 'token' parameter name

https://gerrit.wikimedia.org/r/576918

Change 576918 merged by Ejegg:
[wikimedia/fundraising/SmashPig@master] Adyen recurring: fix 'token' parameter name

https://gerrit.wikimedia.org/r/576918

DStrine closed this task as Resolved.Mar 17 2020, 8:00 PM